Codeforces Round #317 [AimFund Thanks-Round] Editorial

Revision en1, by Kostroma, 2015-08-22 23:24:58

We hope you enjoyed our problems :) We're working on editorials now, other problems will be added as soon as possible =)

572A - Массивы

In this problem one need to check whether it's possible to choose k elements from array A and m elements from array B so that each of chosen element in A is less than each of chosen elements in B. If it's possible then it's possible to choose k smallest elements in A and m largest elements in B. That means that in particular, k-th smallest element of A is less than m-th largest element in B. So, if A[k] < B[n - m + 1] then the answer is "YES" and if not, then the answer is "NO".

Problem author: zeliboba.

Problem developers: riadwaw, Kostroma.

572B - Биржевые заявки

Coming soon.

571A - Удлинение палочек

Let's count the number of ways to form a triple which can't represent triangle sides, and then we subtract this value from — the total number of ways to increase the sticks not more than l in total. This number is obtained from partition of l into 4 summands (la + lb + lc + unusedl = l), or can be counted using a for loop.

Now we consider triples a + la, b + lb, c + lc, where la + lb + lc ≤ l, la, lb, lc ≥ 0. Fix the maximal side, for example it would be a + la. We'll have to do the following algo for b + lb and c + lc in the same way. The triple is not a triangle with maximal side a + la if a + la ≥ b + lb + c + lc. If we iterate over la between 0 and l, we have the following conditions on lb, lc:

lb + lc ≤ a - b - c + la, 
lb + lc ≤ l - la, 

lb, lc ≥ 0. So, non-negative integers lb, lc should be such that lb + lc ≤ min(a - b - c + la, l - la). If we denote this minimum as x than we can choose lb, lc in different ways (again we divide x into three summands: lb, lc and some unused volume). Also when we fix lb, there are x - lb + 1 ways to choose lc, so the overall number of pair lb, lc is

so we obtain the same formula.

To sum up, we need to iterate over the maximal side and over the addition to that side, then write these formulas, and subtract the result from the total number of different additions to the sides. The complexity of the solution is O(l).

Problem author: Kostroma.

Problem developers: Kostroma, riadwaw.

571B - Минимизация

Coming soon.

571C - КНФ-2

Firstly let's assign values to variables occurring in our fomula only with negation or only without negation. After that we can throw away the disjuncts which contained them, since they are already true, and continue the process until it is possible. To make it run in time limit, one should use dfs or bfs algorithm to eliminate these variables and disjuncts.

So now we have only variables which have both types of occurrences in disjucnts. Let's build a graph with the vertices corresponding to disjuncts, and for each varible a make an edge between the disjuncts that contain a and !a. Now we should choose the directions of edges in this graph in such a way that every vertex has at least one incoming edge.

We can notice that if some connected component of this graph is a tree, the solution is not possible: on each step we can take some leaf of this tree, and we have to orient its only edge to it, and then erase the leaf. In the end we'll have only one vertex, and it'll not have any incoming edges.

Otherwise, take some cycle in the component and orient the edges between neighbouring vertices along it. Then run dfs from every vertex of the cycle and orient each visited edge in the direction we went along it. It is easy to easy that after this process every vertex will have at least one incoming edge.

So, we should consider cases with the variables which values can be assigned at once, than construct a graph from disjuncts and variables and find whether each connected component has a cycle. If so, we also should carefully construct the answer, assigning the remaining variables their values, looking at the directions of the edges in the graph. The overall complexity is O(n + m).

Problem author: zeliboba.

Problem developers: Kostroma, zeliboba, yarrr.

571D - Кампус

Coming soon.

571E - Геометрические прогрессии

Coming soon.

Tags aimfund, editorial, tutorial, cf317, thanks-round, maths, div0

History

 
 
 
 
Revisions
 
 
  Rev. Lang. By When Δ Comment
en8 English Kostroma 2015-09-06 17:15:38 473 Tiny change: '8-22].\n\n[probl' -
en7 English Kostroma 2015-08-25 02:04:38 33
en6 English Kostroma 2015-08-24 20:45:59 2589 Tiny change: 'ch plan:\n1. For e' -
en5 English Kostroma 2015-08-23 08:27:15 4 Tiny change: 'c{(l+1)(l+1)(l+2)}{6}$ &md' -> 'c{(l+1)(l+2)(l+3)}{6}$ &md'
en4 English Kostroma 2015-08-23 00:57:19 1757
en3 English Kostroma 2015-08-23 00:19:03 173
en2 English Kostroma 2015-08-23 00:14:12 2650 Tiny change: 'n\nComing soon.\n\n[probl' -> 'n\nComing tomorrow :)\n\n[probl'
en1 English Kostroma 2015-08-22 23:24:58 4692 Initial revision (published)